#include "SATAOperation.hpp"

SATAOperation::SATAOperation(OPERATION_TYPE OprationType, string helpContent) : OperationBaseClass(OprationType, helpContent)
{
     m_pSATADAPI = NULL;
     m_pProgressHandler = NULL;
     switch (OprationType)
     {
     case OPERATION_CONTROLLER:
	  setName("controller");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_DRIVE:
	  setName("drive");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_ALL:
	  setName("all");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_ID:
	  setName("id");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_BDF:
	  setName("bdf");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_PORT:
	  setName("port");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_NODE:
	  setName("node");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_SN:
	  setName("sn");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_MODEL:
	  setName("model");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_FW:
	  setName("fw");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_CAPACITY:
	  setName("capacity");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
/*     case OPERATION_LINK:
	  setName("link");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;*/
     case OPERATION_SPEED:
	  setName("speed");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_TEMP:
	  setName("temp");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_IDENTIFY:
	  setName("identify");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_READPFMC:
	  setName("readpfmc");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_WRITEPFMC:
	  setName("writepfmc");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_WRC:
	  setName("wrc");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_TRANSPORT_STATE_TRANSITION_ERR:
	  setName("transport");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_LINK_SEQUENCE_ERR:
	  setName("linkseq");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_HANDSHAKE_ERR:
	  setName("handshake");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_CRC_ERR:
	  setName("crc");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_DISPARITY_ERR:
	  setName("disparity");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_10B_TO_8B_DECODE_ERR:
	  setName("10b8b");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_PHY_INTERNAL_ERR:
	  setName("phy");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_INTERNAL_ERR:
	  setName("internal");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_PROTOCOL_ERR:
	  setName("protocol");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_PERSISTENT_COMMUNICATION_OR_DATA_INTEGRITY_ERR:
	  setName("comm");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_TRANSIENT_DATA_INTEGRITY_ERR:
	  setName("transient");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_RECOVER_COMMUNICATIONS_ERR:
	  setName("recover_comm");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_RECOVER_DATA_INTREGRITY_ERR:
	  setName("recover_data");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     case OPERATION_SMART:
	  setName("smart");
	  setHelp(helpContent);
	  m_OperationType = OprationType;
	  break;
     default:
	  break;
     }
}

SATAOperation::~SATAOperation()
{
     if(m_pSATADAPI != NULL)
     {
	  delete m_pSATADAPI;
     }
     if(m_pProgressHandler != NULL)
     {
	  delete m_pProgressHandler;
     }
}

INT32 SATAOperation::executeOperation(StringParser CommandLine)
{
     INT32 s32Err = 0;

     string strStrParameter1 = "";
     CommandLine.getParameter(&strStrParameter1, 0);

     COMMAND_TYPE eCommandType;
     CommandLine.getCommandType(&eCommandType);
     //If the first parameter is "help" or space, show help message
     if(eCommandType == CMD_LIST)
     {
	  strStrParameter1 = NO_OPRATION;
     }
     else
     {
	  if(strStrParameter1==HELP || strStrParameter1=="")
	  {
	       helpParameter();
	       s32Err = -1;
	       return s32Err;
	  }
     }

     //Execute operation
     switch(m_OperationType)
     {
     case OPERATION_CONTROLLER:
     case OPERATION_DRIVE:
	  s32Err = executeList(CommandLine);
	  break;
     case OPERATION_ALL:
	  if(eCommandType == CMD_LIST)
	  {
	       s32Err = executeList(CommandLine);
	  }
	  else if(eCommandType == CMD_SHOW)
	  {
	       s32Err = executeShow(CommandLine);
	  }
	  else if(eCommandType == CMD_ERROR)
	  {
	       s32Err = executeError(CommandLine);
	  }
	  break;
     case OPERATION_ID:
     case OPERATION_BDF:
     case OPERATION_PORT:
/*	  if(eCommandType == CMD_LIST)
	  {
	       s32Err = executeList(CommandLine);
	  }
	  else if(eCommandType == CMD_SHOW)*/
	  {
	       s32Err = executeShow(CommandLine);
	  }
	  break;
     case OPERATION_NODE:
     case OPERATION_SN:
     case OPERATION_MODEL:
     case OPERATION_FW:
     case OPERATION_CAPACITY:
//     case OPERATION_LINK:
     case OPERATION_SPEED:
     case OPERATION_TEMP:
	  s32Err = executeShow(CommandLine);
	  break;
     case OPERATION_IDENTIFY:
     case OPERATION_READPFMC:
     case OPERATION_WRITEPFMC:
     case OPERATION_WRC:
	  s32Err = executeTest(CommandLine);
	  break;
     case OPERATION_TRANSPORT_STATE_TRANSITION_ERR:
     case OPERATION_LINK_SEQUENCE_ERR:
     case OPERATION_HANDSHAKE_ERR:
     case OPERATION_CRC_ERR:
     case OPERATION_DISPARITY_ERR:
     case OPERATION_10B_TO_8B_DECODE_ERR:
     case OPERATION_PHY_INTERNAL_ERR:
     case OPERATION_INTERNAL_ERR:
     case OPERATION_PROTOCOL_ERR:
     case OPERATION_PERSISTENT_COMMUNICATION_OR_DATA_INTEGRITY_ERR:
     case OPERATION_TRANSIENT_DATA_INTEGRITY_ERR:
     case OPERATION_RECOVER_COMMUNICATIONS_ERR:
     case OPERATION_RECOVER_DATA_INTREGRITY_ERR:
	  s32Err = executeError(CommandLine);
	  break;
     case OPERATION_SMART:
	  s32Err = executeUtility(CommandLine);
	  break;
     default:
	  cout << "Unsupport operation" << endl;
	  s32Err = -1; 
	  return s32Err;
	  break;
     }
     return s32Err;
}

INT32 SATAOperation::helpParameter()
{
     //Show parameter help message depend on operation type
     switch (m_OperationType)
     {
     case OPERATION_ALL:
     case OPERATION_ID:
     case OPERATION_BDF:
     case OPERATION_PORT:
     case OPERATION_NODE:
     case OPERATION_SN:
     case OPERATION_MODEL:
     case OPERATION_FW:
     case OPERATION_CAPACITY:
//     case OPERATION_LINK:
     case OPERATION_SPEED:
     case OPERATION_TEMP:
	  cout << "Show SATA Device Characteristic" << endl;
	  cout << "Syntax: P1 P2" << endl;
	  cout << "P1: Data Elements" << endl;
	  cout << "P2: Drive wellKnownName" << endl;
	  break;
     case OPERATION_IDENTIFY:
	  cout << "SATA Device Identify Command Test" << endl;
	  cout << "Syntax: identify P1" << endl;
	  cout << "P1: Drive wellKnownName" << endl;
	  break;
     case OPERATION_READPFMC:
	  cout << "SATA Device Read Performance Test" << endl;
	  cout << "Syntax: readpfmc P1 P2 P3" << endl;
	  cout << "P1: Start Sector(Hex)" << endl;
	  cout << "P2: Test Size/MB(Dec)" << endl;
	  cout << "P3: Drive wellKnownName" << endl;
	  break;
     case OPERATION_WRITEPFMC:
	  cout << "SATA Device Write Performance Test" << endl;
	  cout << "Syntax: writepfmc P1 P2 P3" << endl;
	  cout << "P1: Start Sector(Hex)" << endl;
	  cout << "P2: Test Size/MB(Dec)" << endl;
	  cout << "P3: Drive wellKnownName" << endl;
	  break;
     case OPERATION_WRC:
	  cout << "SATA Device ReadWrite Test" << endl;
	  cout << "Syntax: wrc P1 P2 P3" << endl;
	  cout << "P1: Start Sector(Hex)" << endl;
	  cout << "P2: Test Size/MB(Dec)" << endl;
	  cout << "P3: Drive wellKnownName" << endl;
	  break;
     case OPERATION_TRANSPORT_STATE_TRANSITION_ERR:
     case OPERATION_LINK_SEQUENCE_ERR:
     case OPERATION_HANDSHAKE_ERR:
     case OPERATION_CRC_ERR:
     case OPERATION_DISPARITY_ERR:
     case OPERATION_10B_TO_8B_DECODE_ERR:
     case OPERATION_PHY_INTERNAL_ERR:
     case OPERATION_INTERNAL_ERR:
     case OPERATION_PROTOCOL_ERR:
     case OPERATION_PERSISTENT_COMMUNICATION_OR_DATA_INTEGRITY_ERR:
     case OPERATION_TRANSIENT_DATA_INTEGRITY_ERR:
     case OPERATION_RECOVER_COMMUNICATIONS_ERR:
     case OPERATION_RECOVER_DATA_INTREGRITY_ERR:
	  cout << "SATA Device Error Register" << endl;
	  cout << "Syntax: P1 P2" << endl;
	  cout << "P1: Error Data Elements" << endl;
	  cout << "P2: Drive wellKnownName" << endl;
	  break;
     case OPERATION_SMART:
	  cout << "SATA Device SMART information" << endl;
	  cout << "Syntax: smart P1 P2 P1" << endl;
	  cout << "P1: Attribute Start ID" << endl;
	  cout << "P2: Attribute End ID" << endl;
	  cout << "P3: Drive wellKnownName" << endl;
	  break;
     default:
	  break;
     }
     return 0;
}

INT32 SATAOperation::executeList(StringParser CommandLine)
{
     INT32 s32Err = 0;
     ErrorMsg *pErrorMsg = NO_ERROR_MSG;
     
     m_pSATADAPI = new SATADAPI("SATADAPI");

     s32Err = checkSyntax(CommandLine);
     if(s32Err == 0)
     {
	  switch(m_OperationType)
	  {
	  case OPERATION_CONTROLLER:
	       pErrorMsg = m_pSATADAPI->IOCTL(0, eListController);
	       break;
/*	  case OPERATION_PORT:
	       pErrorMsg = m_pSATADAPI->IOCTL(0, eListPort);
	       break;*/
	  case OPERATION_DRIVE:
	       pErrorMsg = m_pSATADAPI->IOCTL(0, eListDrive);
	       break;
	  default:
	       cout << "no such operation" << endl;
	       s32Err = -1;
	       return s32Err;
	       break;
	  }
	  if(pErrorMsg != NO_ERROR_MSG)
	  {
	       printError(pErrorMsg);
	       s32Err = -1;
	       return s32Err;
	  }
     }
     return s32Err;
}

INT32 SATAOperation::executeShow(StringParser CommandLine)
{
     INT32 s32Err = 0;
     ErrorMsg *pErrorMsg = NO_ERROR_MSG;
     UINT32 u32LogicalID = 0;
     SATADataElement eSATADataElement = (SATADataElement)0;

     string strTargetName = "";
     string strReturnData = "";

     m_pSATADAPI = new SATADAPI("SATADAPI");

     s32Err = checkSyntax(CommandLine);
     if(s32Err == 0)
     {
	  CommandLine.getParameter(&strTargetName, 0);
	  strTargetName = convertStringToUpperCase(strTargetName);
	  //printf("2nd Parameter:%s\n", strTargetName.c_str());
	  switch(m_OperationType)
	  {
	  case OPERATION_ALL:
	       if(strTargetName.find("DRIVE")!=string::npos || strTargetName.find("PORT")!=string::npos)
	       {
		    eSATADataElement = eDriveDataAll;

	       }
	       else if(strTargetName.find("SATA")!=string::npos && strTargetName.find("DRIVE")==string::npos && strTargetName.find("PORT")==string::npos)
	       {
		    eSATADataElement = eControllerDataAll;
	       }
	       else
	       {
		    cout << "input wellKnownName error !!!" << endl;
		    return -1;
	       }
	       break;
	  case OPERATION_ID:
	       eSATADataElement = eControllerID;
	       break;
	  case OPERATION_BDF:
	       eSATADataElement = eControllerBDF;
	       break;
	  case OPERATION_PORT:
	       if (strTargetName.find("DRIVE") == string::npos)
	       {
		    eSATADataElement = eControllerPortAmount;
	       }
	       else
	       {
		    eSATADataElement = eDrivePortNumber;
	       }
	       break;
	  case OPERATION_NODE:
	       eSATADataElement = eDriveDeviceNodeName;
	       break;
	  case OPERATION_SN:
	       eSATADataElement = eDriveSerialNumber;
	       break;
	  case OPERATION_MODEL:
	       eSATADataElement = eDriveModelName;
	       break;
	  case OPERATION_FW:
	       eSATADataElement = eDriveFirmwareVersion;
	       break;
	  case OPERATION_CAPACITY:
	       eSATADataElement = eDriveCapacity;
	       break;
//	  case OPERATION_LINK:
//	       eSATADataElement = eDriveLinkStatus;
//	       break;
	  case OPERATION_SPEED:
	       eSATADataElement = eDriveLinkSpeed;
	       break;
	  case OPERATION_TEMP:
	       eSATADataElement = eDriveTemperature;
	       break;
	  default:
	       cout << "no such data element" << endl;
	       return -1;
	       break;
	  }
	  if((pErrorMsg = m_pSATADAPI->getLogicalIdByName(strTargetName, &u32LogicalID)) != NO_ERROR_MSG)
	  {
	       printError(pErrorMsg);
	       return -1;
	  }
	  if((pErrorMsg = m_pSATADAPI->getDataByID(u32LogicalID, eSATADataElement, &strReturnData)) != NO_ERROR_MSG)
	  {
	       printError(pErrorMsg);
	       return -1;
	  }
	  else
	  {
	       cout << strReturnData <<endl;
	  }
     }
     return s32Err;
}

INT32 SATAOperation::executeTest(StringParser CommandLine)
{
     INT32 s32Err = 0;

     ErrorMsg *pErrorMsg = NO_ERROR_MSG;

     UINT32 u32LogicalID = 0;
     INT32 s32StartSector = 0;
     INT32 s32TestSize = 0;

     string strTempString = "";
     strTempString.clear();

     string strTargetName = "";
     strTargetName.clear();

     m_pSATADAPI = new SATADAPI("SATADAPI");

     s32Err = checkSyntax(CommandLine);
     if(s32Err == 0)
     {
	  if(m_OperationType != OPERATION_IDENTIFY)
	  {
	       CommandLine.getParameter(&strTempString, 0);
//	  printf("1st Parameter:%s\n", strTempString.c_str());
	       CommandLine.convertStringToHex(strTempString, &s32StartSector);
//	  printf("1st ParameterToHex:%d\n", s32StartSector);
	       strTempString.clear();

	       CommandLine.getParameter(&strTempString, 1);
//	  printf("2nd Parameter:%s\n", strTempString.c_str());
	       CommandLine.convertStringToDec(strTempString, &s32TestSize);
//	  printf("2nd ParameterToHex:%d\n", s32TestSize);
	       strTempString.clear();

	       CommandLine.getParameter(&strTargetName, 2);
	       strTargetName = convertStringToUpperCase(strTargetName);
//	  printf("3rd Parameter:%s\n", strTargetName.c_str());
	  }

	  switch(m_OperationType)
	  {
	  case OPERATION_IDENTIFY:
	       CommandLine.getParameter(&strTargetName, 0);
	       strTargetName = convertStringToUpperCase(strTargetName);
	       //printf("1st Parameter:%s\n", strTargetName.c_str());
	       if((pErrorMsg = m_pSATADAPI->getLogicalIdByName(strTargetName.c_str(), &u32LogicalID)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    s32Err = -1;

		    return s32Err;
	       }
	       //printf("Operation-executeShow-LogicalID=%u\n",u32LogicalID );
	       if((pErrorMsg = m_pSATADAPI->identifyCommandTest(u32LogicalID)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    s32Err = -1;
		    return s32Err;
	       }
	       break;
	  case OPERATION_READPFMC:
	       m_pProgressHandler = new thread(&SATAOperation::handleTestProgress, this, (UINT32)s32TestSize);
	       if((pErrorMsg = m_pSATADAPI->getLogicalIdByName(strTargetName.c_str(), &u32LogicalID)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    s32Err = -1;
		    return s32Err;
	       }
	       if((pErrorMsg = m_pSATADAPI->readPerformanceTest(u32LogicalID, (UINT32)s32StartSector, (UINT32)s32TestSize)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    s32Err = -1;
		    return s32Err;
	       }
	       m_pProgressHandler->join();
	       break;
	  case OPERATION_WRITEPFMC:
	       m_pProgressHandler = new thread(&SATAOperation::handleTestProgress, this, (UINT32)s32TestSize);
	       if((pErrorMsg = m_pSATADAPI->getLogicalIdByName(strTargetName.c_str(), &u32LogicalID)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    s32Err = -1;
		    return s32Err;
	       }
	       if((pErrorMsg =m_pSATADAPI->writePerformanceTest(u32LogicalID, (UINT32)s32StartSector, (UINT32)s32TestSize)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    s32Err = -1;
		    return s32Err;
	       }
	       m_pProgressHandler->join();
	       break;
	  case OPERATION_WRC:
	       m_pProgressHandler = new thread(&SATAOperation::handleTestProgress, this, (UINT32)s32TestSize);
	       if((pErrorMsg = m_pSATADAPI->getLogicalIdByName(strTargetName.c_str(), &u32LogicalID)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    s32Err = -1;
		    return s32Err;
	       }
	       if((pErrorMsg = m_pSATADAPI->readwriteTest(u32LogicalID, (UINT32)s32StartSector, (UINT32)s32TestSize)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    s32Err = -1;
		    return s32Err;
	       }
	       m_pProgressHandler->join();
	       break;
	  default:
	       cout << "Unsupport operation" << endl;
	       s32Err = -1;
	       return s32Err;
	       break;
	  }

	  cout << m_pSATADAPI->m_strOutputResultString;
	  cout << "Pass" << endl;
     }
     return s32Err;
}

INT32 SATAOperation::executeError(StringParser CommandLine)
{
     INT32 s32Err = 0;
     ErrorMsg *pErrorMsg = NO_ERROR_MSG;

     UINT32 u32LogicalID = 0;
     SATAErrorElement eSATAErrorElement = (SATAErrorElement)0;

     string strTargetName = "";
     string strReturnData = "";

     m_pSATADAPI = new SATADAPI("SATADAPI");
     s32Err = checkSyntax(CommandLine);
     if(s32Err == 0)
     {
	  CommandLine.getParameter(&strTargetName, 0);
	  strTargetName = convertStringToUpperCase(strTargetName);
	  //printf("2nd Parameter:%s\n", strTargetName.c_str());
	  switch(m_OperationType)
	  {
	  case OPERATION_ALL:
	       eSATAErrorElement = eAllErr;
	       break;
	  case OPERATION_TRANSPORT_STATE_TRANSITION_ERR:
	       eSATAErrorElement = eTransportStateTransitionErr;
	       break;
	  case OPERATION_LINK_SEQUENCE_ERR:
	       eSATAErrorElement = eLinkSequenceErr;
	       break;
	  case OPERATION_HANDSHAKE_ERR:
	       eSATAErrorElement = eHandshakeErr;
	       break;
	  case OPERATION_CRC_ERR:
	       eSATAErrorElement = eCRCErr;
	       break;
	  case OPERATION_DISPARITY_ERR:
	       eSATAErrorElement = eDisparityErr;
	       break;
	  case OPERATION_10B_TO_8B_DECODE_ERR:
	       eSATAErrorElement = e10bTo8bDecodeErr;
	       break;
	  case OPERATION_PHY_INTERNAL_ERR:
	       eSATAErrorElement = ePHYInternalErr;
	       break;
	  case OPERATION_INTERNAL_ERR:
	       eSATAErrorElement = eInternalErr;
	       break;
	  case OPERATION_PROTOCOL_ERR:
	       eSATAErrorElement = eProtocolErr;
	       break;
	  case OPERATION_PERSISTENT_COMMUNICATION_OR_DATA_INTEGRITY_ERR:
	       eSATAErrorElement = ePersistentCommunicationOrDataIntegrityErr;
	       break;
	  case OPERATION_TRANSIENT_DATA_INTEGRITY_ERR:
	       eSATAErrorElement = eTransientDataIntegrityErr;
	       break;
	  case OPERATION_RECOVER_COMMUNICATIONS_ERR:
	       eSATAErrorElement = eRecoverCommunicationErr;
	       break;
	  case OPERATION_RECOVER_DATA_INTREGRITY_ERR:
	       eSATAErrorElement = eRecoverDataIntegrityErr;
	       break;
	  default:
	       cout << "no such data element" << endl;
	       s32Err = -1;
	       return s32Err;
	       break;
	  }
//	  m_pSATADAPI->getDataByName(strTargetName, eSATAErrorElement);
	  if((pErrorMsg = m_pSATADAPI->getLogicalIdByName(strTargetName, &u32LogicalID)) != NO_ERROR_MSG)
	  {
	       printError(pErrorMsg);
	       s32Err = -1;
	       return s32Err;
	  }
//	  cout << "lid = " << u32LogicalID << endl;
	  //printf("Operation-executeShow-LogicalID=%d\n",u32LogicalID );
//	  cout << "data element = " << eSATAErrorElement << endl;
	  if((pErrorMsg = m_pSATADAPI->getErrorRegisterByID(u32LogicalID, eSATAErrorElement, &strReturnData)) != NO_ERROR_MSG)
	  {
	       printError(pErrorMsg);
	       s32Err = -1;
	       return s32Err;
	  }
	  cout << strReturnData <<endl;
     }
     return s32Err;
}

INT32 SATAOperation::executeUtility(StringParser CommandLine)
{
     INT32 s32Err = 0;
     ErrorMsg *pErrorMsg = NO_ERROR_MSG;

     UINT32 u32LogicalID = 0;
     INT32 s32StartIDNumber = 0;
     INT32 s32EndIDNumber = 0;

     string strTempString = "";
     strTempString.clear();
     string strTargetName = "";
     strTargetName.clear();
     string strReturnData = "";
     strReturnData.clear();

     m_pSATADAPI = new SATADAPI("SATADAPI");

     s32Err = checkSyntax(CommandLine);
     if(s32Err == 0)
     {
	  CommandLine.getParameter(&strTempString, 0);
//	  printf("1st Parameter:%s\n", strTempString.c_str());
	  CommandLine.convertStringToHex(strTempString, &s32StartIDNumber);
//	  printf("1st ParameterToHex:%d\n", s32StartIDNumber);
	  strTempString.clear();

	  CommandLine.getParameter(&strTempString, 1);
//	  printf("2nd Parameter:%s\n", strTempString.c_str());
	  CommandLine.convertStringToHex(strTempString, &s32EndIDNumber);
//	  printf("2nd ParameterToHex:%d\n", s32EndIDNumber);
	  strTempString.clear();

	  CommandLine.getParameter(&strTargetName, 2);
	  strTargetName = convertStringToUpperCase(strTargetName);
//	  printf("3rd Parameter:%s\n", strTargetName.c_str());
	  strTempString.clear();

	  switch(m_OperationType)
	  {
	  case OPERATION_SMART:
	       if((pErrorMsg = m_pSATADAPI->getLogicalIdByName(strTargetName, &u32LogicalID)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    return -1;
	       }
	       if((pErrorMsg =m_pSATADAPI->getSMARTInfoByID(u32LogicalID, (UINT32)s32StartIDNumber, (UINT32)s32EndIDNumber, &strReturnData)) != NO_ERROR_MSG)
	       {
		    printError(pErrorMsg);
		    return -1;
	       }
	       cout << strReturnData << endl;
	       break;
	  default:
	       cout << "Unsupport operation" << endl;
	       return -1;
	       break;
	  }
     }
     return s32Err;
}

INT32 SATAOperation::checkSyntax(StringParser CommandLine)
{
     INT32  s32CNT, s32aHex[2], s32ParameterNumber = 0;
     string straParameter[7];
     int    s32Err = 0;

     CommandLine.getParameterNumber(&s32ParameterNumber);

     COMMAND_TYPE eCommandType = (COMMAND_TYPE)0;
     CommandLine.getCommandType(&eCommandType);

//     printf("s32ParameterNumber=%d\n", s32ParameterNumber);
     switch(m_OperationType)
     {
     case NO_OPRATION:
	  if(s32ParameterNumber > 0)
	  {
	       cout << "Not Necessary Operation Parameter" << endl;
	       helpParameter();
	       return -1;
	  }
	  break;
     case OPERATION_CONTROLLER:
     case OPERATION_DRIVE:
	  if(s32ParameterNumber != 0)
	  {
	       cout << "Number of parameter != 0" << endl;
	       helpParameter();
	       return -1;
	  }
	  break;
     case OPERATION_ALL:
	  if(eCommandType == CMD_LIST)
	  {
	       if (s32ParameterNumber != 0)
	       {
		    cout << "Number of parameter != 0" << endl;
		    helpParameter();
		    return -1;
	       }
	  }
	  else if(eCommandType == CMD_SHOW)
	  {
	       //Check parameter number
	       if (s32ParameterNumber != 1)
	       {
		    cout << "Parameter numbers isn't 1" << endl;
		    helpParameter();
		    return -1;
	       }
	  }
	  else if(eCommandType == CMD_ERROR)
	  {
	       //Check parameter number
	       if(s32ParameterNumber != 1)
	       {
		    cout << "Parameter numbers isn't 1" << endl;
		    helpParameter();
		    return -1;
	       }
	  }
	  else
	  {
	       cout << "Unknown Command" << endl;
	       helpParameter();
	       return -1;
	  }
	  break;
     case OPERATION_ID:
     case OPERATION_BDF:
     case OPERATION_PORT:
/*	  if(eCommandType == CMD_LIST)
	  {
	       if (s32ParameterNumber != 0)
	       {
		    cout << "Number of parameter != 0" << endl;
		    helpParameter();
		    return -1;
	       }
	  }
	  else*/
	  {
	       //Check parameter number
	       if (s32ParameterNumber != 1)
	       {
		    cout << "Parameter numbers isn't 1" << endl;
		    helpParameter();
		    return -1;
	       }
	  }
	  break;
	  // for show
     case OPERATION_NODE:
     case OPERATION_SN:
     case OPERATION_MODEL:
     case OPERATION_FW:
     case OPERATION_CAPACITY:
//     case OPERATION_LINK:
     case OPERATION_SPEED:
     case OPERATION_TEMP:
	  // for errors
     case OPERATION_TRANSPORT_STATE_TRANSITION_ERR:
     case OPERATION_LINK_SEQUENCE_ERR:
     case OPERATION_HANDSHAKE_ERR:
     case OPERATION_CRC_ERR:
     case OPERATION_DISPARITY_ERR:
     case OPERATION_10B_TO_8B_DECODE_ERR:
     case OPERATION_PHY_INTERNAL_ERR:
     case OPERATION_INTERNAL_ERR:
     case OPERATION_PROTOCOL_ERR:
     case OPERATION_PERSISTENT_COMMUNICATION_OR_DATA_INTEGRITY_ERR:
     case OPERATION_TRANSIENT_DATA_INTEGRITY_ERR:
     case OPERATION_RECOVER_COMMUNICATIONS_ERR:
     case OPERATION_RECOVER_DATA_INTREGRITY_ERR:
	  //Check parameter number
	  if (s32ParameterNumber != 1)
	  {
	       cout << "Parameter numbers isn't 1" << endl;
	       helpParameter();
	       return -1;
	  }
	  break;
     case OPERATION_IDENTIFY:
	  if (s32ParameterNumber != 1)
	  {
	       cout << "Parameter numbers isn't 1" << endl;
	       helpParameter();
	       return -1;
	  }
	  break;
     case OPERATION_READPFMC:
     case OPERATION_WRITEPFMC:
     case OPERATION_WRC:
	  if (s32ParameterNumber != 3)
	  {
	       cout << "Parameter numbers isn't 3" << endl;
	       helpParameter();
	       return -1;
	  }
	  //Get parameter
	  for(s32CNT=0; s32CNT<s32ParameterNumber; s32CNT++)
	  {
	       CommandLine.getParameter(&straParameter[s32CNT], s32CNT);
	  }
	  //Check parameter 1 is numeric
	  s32Err = CommandLine.convertStringToHex(straParameter[0], &s32aHex[0]);
	  if(s32Err != 0)
	  {
	       cout << "parameter 1 isn't numeric." << endl;
	       helpParameter();
	       return -1;
	  }
	  //Check parameter 2 is numeric
	  s32Err = CommandLine.convertStringToHex(straParameter[1], &s32aHex[1]);
	  if(s32Err != 0)
	  {
	       cout << "parameter 2 isn't numeric." << endl;
	       helpParameter();
	       return -1;
	  }
	  break;
     case OPERATION_SMART:
	  if(s32ParameterNumber != 3)
	  {
	       cout << "Parameter numbers isn't 3" << endl;
	       helpParameter();
	       return -1;
	  }
	  //Get parameter
	  for(s32CNT=0; s32CNT<s32ParameterNumber; s32CNT++)
	  {
	       CommandLine.getParameter(&straParameter[s32CNT], s32CNT);
	  }
	  //Check parameter 1 is numeric
	  s32Err = CommandLine.convertStringToHex(straParameter[0], &s32aHex[0]);
	  if(s32Err != 0)
	  {
	       cout << "parameter 1 isn't numeric." << endl;
	       helpParameter();
	       return -1;
	  }
	  //Check parameter 12 is numeric
	  s32Err = CommandLine.convertStringToHex(straParameter[1], &s32aHex[1]);
	  if(s32Err != 0)
	  {
	       cout << "parameter 2 isn't numeric." << endl;
	       helpParameter();
	       return -1;
	  }
	  break;
     default:
	  cout << "Unsupport operation" << endl;
	  return -1;
	  break;
     }
     return 0;
}

void SATAOperation::handleTestProgress(UINT32 in_u32TestSizeMB)
{
     INT32 s32Progress = 0;

     sleep(1);
     while(s32Progress < 100)// <= 100%
     {
	  sleep(1);
	  s32Progress = m_pSATADAPI->getProgress();
	  printf("Progressing: %3u%% \r", s32Progress);
	  fflush(stdout);
     }
     printf("\n");
}


string SATAOperation::convertStringToUpperCase(string in_strInputString)
{
     string strOutputString = "";
     for(string::iterator stringIterator = in_strInputString.begin(); stringIterator != in_strInputString.end(); stringIterator++)
     {
          strOutputString += toupper(*stringIterator);
     }
     return strOutputString;
}
