#ifndef SATAOPERATION_H
#define SATAOPERATION_H

//#include <stdio.h>
#include <iostream>
#include <string>
#include <thread>

#include "OperationBaseClass.hpp"
#include "SATADAPI.hpp"

using namespace std;

class SATAOperation: public OperationBaseClass
{
public:
     SATAOperation(OPERATION_TYPE, string);
     virtual  ~SATAOperation();

     //Decide which operation to be executed
     INT32 executeOperation(StringParser);

     //List SATA device node
     INT32 executeList(StringParser);

     //Show SATA device characteristics
     INT32 executeShow(StringParser);

     //Execute test command
     INT32 executeTest(StringParser);

     //Execute test command
     INT32 executeError(StringParser);

     //Execute test command
     INT32 executeUtility(StringParser);

     //Show parameter message here
     INT32 helpParameter();

     //Check parameter syntax here
     INT32 checkSyntax(StringParser);
                
private:
     OPERATION_TYPE m_OperationType;
     SATADAPI       *m_pSATADAPI;
     thread         *m_pProgressHandler;
     void handleTestProgress(UINT32 in_u32TestSizeMB);
     string convertStringToUpperCase(string in_strInputString);
};

#endif
