/*******************************************************************************

NAME			$RCSfile: commDebug.h,v $
SUMMARY			Diagnostic linux debug for PikesPeak
VERSION			$Revision: 1.1.1.1 $
UPDATE DATE		$Date: 2009/05/20 07:34:28 $
PROGRAMMER		$Author: lecter $

		Copyright 2009 LSI Corporation. All Rights Reserved.

DESCRIPTION:
    Contains the linux debug function of all the component.

REFERENCE:

*******************************************************************************/

#ifndef __INCcommDebug
#define __INCcommDebug

#define ASSERT_() do { \
	dump_stack();	\
	panic("assertion \"%s\" failed: file \"%s\", line %d\n", __FUNCTION__, __FILE__, __LINE__); \
} while (0)

#define ASSERT(condition) do { \
	if (unlikely((condition)==0)) ASSERT_(); \
} while(0)

#define ASSERT_BLOCK(cond, code) do { \
    if ((cond) == 0) { \
		code \
		ASSERT_(); \
	}	\
} while (0)

#endif 	//__INCcommDebug
