#include <linux/list.h>
#include <linux/sched.h>
#include <linux/kthread.h>
#include <linux/slab.h>
#include <linux/net.h>
#include <linux/in.h>
#include <linux/socket.h>
#include <linux/tcp.h>
#include <linux/proc_fs.h>

#ifdef EIPC_DEBUG
#define DPRINTK printk
#else
#define DPRINTK(fmt...) do { } while(0)
#endif


typedef struct 
{
	struct task_struct *eTask;
	struct kmem_cache *eIpcCache;
	struct socket *txSocket;
	spinlock_t txLock;
	spinlock_t rxLock;

	struct list_head freeTxQueue;
	struct list_head freeRxQueue;
	struct list_head txQueue;
	struct list_head rxQueue;
} EIPC_CB;

