/*******************************************************************************

NAME			$RCSfile: commPattern.h,v $
SUMMARY			Diagnostic patterns for PikesPeak
VERSION			$Revision: 1.4 $
UPDATE DATE		$Date: 2009/07/14 04:19:46 $
PROGRAMMER		$Author: lecter $

		Copyright 2009 LSI Corporation. All Rights Reserved.

DESCRIPTION:
    Contains the diagnostic patterns of all the component.

REFERENCE:

*******************************************************************************/
#ifndef __commPattern
#define __commPattern

/***  INCLUDES  ***/
#include <commTypes.h>

/***  CONSTANT DEFINATIONS  ***/
#define DMA_DIAG_PATTERN_NUM			12
#define	RAM_DATALINES_PATTERNS_NUMBER		7
#define	RAM_DWORD_PATTERNS_NUMBER		6
#define	NVSRAM_DATALINES_PATTERNS_NUMBER	4
#define	NVSRAM_BYTE_PATTERNS_NUMBER		7
#define	SATA_DIAG_PATTERNS_NUMBER		8

/***  EXTERNAL REFERENCES  ***/
extern	UINT8 	gDMAPatternCnt;
extern	UINT8	gMemDLPatternCnt;
extern	UINT8	gMemDWPatternCnt;
extern	UINT8	gNvsramDataLinesPatternsCnt;
extern	UINT8 	gNvsramBytePatternsCnt;
extern	UINT8	gSATAPatternCnt;

extern	UINT32	gDMAPattern[DMA_DIAG_PATTERN_NUM];
extern	UINT32	gMemDLPattern[RAM_DATALINES_PATTERNS_NUMBER];
extern	UINT32	gMemDWPattern[RAM_DWORD_PATTERNS_NUMBER];
extern	UINT32	gSATAPattern[SATA_DIAG_PATTERNS_NUMBER];

extern UINT8 gSAS2008EepromPattern[8];
extern UINT8 gVPDEepromPattern[8];
extern UINT8 gNvsramDataLinesPatterns[NVSRAM_DATALINES_PATTERNS_NUMBER];
extern UINT8 gNvsramBytePatterns[NVSRAM_BYTE_PATTERNS_NUMBER];

#endif //__commPattern
