/****************************************************************
 * Copyright (c) 2008 by Quanta Computer, Inc.  All rights reserved.
 *
 * File Name: ca_offload_struct.h 1.00
 *
 * Abstract:
 * Description: Cache Offload Diagnostics Struct header file
 *
 * Project Name: Aurora
 * Software Component: Adma Diagnostics
 *
 * Exported Functions:
 *      None
 *
 * Notes:
 * History:
 *         2005/12/01 Lecter - Initial Implement
 *** END OF REVISION HISTORY ***********************************/
#ifndef __CA_OFFLOAD_STRUCT_H__
#define __CA_OFFLOAD_STRUCT_H__
#include <linux/list.h>
#include <linux/wait.h>

#include "commMEC.h"
#include "commRpt.h"
#include "commTypes.h"
#include "commDebug.h"

#define USB_TEST_MAX_FLASH_DEVICE			4
#define USB_TEST_DEFAULT_FLASH_DEVICE		1
#define USB_TEST_OFFSET_IN_SECTOR			512 
#define USB_TRANSFER_TEST_SIZE				1
#define USB_TEST_PERFORMANCE_PRORCESS		15
#define USB_TEST_TOTAL_PROGRESS_UINT		100
#define USB_TEST_MAX_REPEAT_TIME			3

#define USB_FLASH_MAX_TRANSFER_SIZE			(512 * KB)
#define USB_FLASH_PERFORMANCE_TEST_SIZE		(20 * MB)
#define USB_FLASH_PERFORMANCE_TEST_TARGET	1
#define USB_FLASH_PERFORMANCE_TEST_ROUND	3
#define USB_FLASH_PERFORMANCE_TEST_RAMP_UP	1
#define USB_FLASH_PERFORMANCE_BIAS			5
#define USB_FLASH_PERFORMANCE_RPT_VALUE		((USB_FLASH_PERFORMANCE_TEST_SIZE / USB_FLASH_MAX_TRANSFER_SIZE) / USB_TEST_PERFORMANCE_PRORCESS)

typedef struct USBTestControlClockStruct {
	struct list_head	nodeUCB;
	struct usb_device	*pUSBDev;
	struct us_data 		*pUSData;
}USBCB;

/* Device Descriptor */
#define USB_STORAGE_DEVICE_ERROR					0x01
#define USB_STORAGE_DEVICE_DEVICE_CLASS				0x00
#define USB_STORAGE_DEVICE_DEVICE_SUB_CLASS			0x00
#define USB_STORAGE_DEVICE_DEVICE_PROTOCOL			0x00
#define USB_STORAGE_DEVICE_NUM_CONFIGURATIONS		0x01

/* Configuration Descriptor */
#define USB_STORAGE_CONFIG_ERROR					0x02
#define USB_STORAGE_CONFIG_M_ATTRIBUTE				0x80

/* Interface Descriptor */
#define USB_STORAGE_INTERFACE_ERROR					0x04
#define USB_STORAGE_INTERFACE_CLASS					0x08
#define USB_STORAGE_INTERFACE_SUB_CLASS				0x06
#define USB_STORAGE_INTERFACE_PROTOCOL				0x50

/* Endpoint Descriptor */
#define USB_STORAGE_ENDPOINT_ERROR 					0x08
#define USB_STORAGE_ENDPOINT_M_ATTRIBUTES 			0x02
#define USB_STORAGE_ENDPOINT_MAX_PACKET_SIZE		0x00
#define USB_STORAGE_ENDPOINT_TRANTYPE_INTERRUPT     0x03
#endif 	//__CA_OFFLOAD_STRUCT_H__
