/*******************************************************************************

NAME			$RCSfile: commIpcApi.h,v $
SUMMARY			Header file of IPC APIs for inter-controller communication
VERSION			$Revision: 1.9 $
UPDATE DATE		$Date: 2010/01/28 08:10:49 $
PROGRAMMER		$Author: jim $

		Copyright 2009 LSI Corporation. All Rights Reserved.

DESCRIPTION:

REFERENCE:

*******************************************************************************/
#ifndef __INCcommIpcApi
#define __INCcommIpcApi

#include <linux/list.h>

#define EIPC_DEFAULT_PORT 2382

/* app & type */
enum {
	IPC_APP_ECHO = 0,
	IPC_APP_GET_TEMP,
	IPC_APP_START_PLX_IPC,
	IPC_APP_STOP_PLX_IPC,
	IPC_APP_REQUEST_POWER_CYCLE,
	IPC_APP_IO_TEST_RUN,	
	IPC_APP_IO_TEST_STOP,
	IPC_APP_GET_DYNAMO_STAT,
	IPC_APP_GET_QE8_CNT,
	IPC_APP_FIXTURE_SAS_INIT,
	IPC_APP_FIXTURE_SAS_READY,
	IPC_APP_ALT_CTRL_READY_REQ,
	IPC_APP_ALT_CTRL_READY_REPLY,
	IPC_APP_FIXTURE_FALCON_PHY_DISABLE_INIT,
	IPC_APP_FIXTURE_FALCON_PHY_DISABLE_READY,
	IPC_APP_HW_VALIDATION,
	IPC_APP_FIXTURE_SAS_INIT_FORCE,	//DVT3
	IPC_APP_UUT_SAS_INIT,		//PVT
	IPC_APP_UUT_SAS_READY,		//PVT
#include "IPCforStress_H.inc"
	IPC_APP_MAX
};

enum {
	IPC_TYPE_SERIAL	= 0,
	IPC_TYPE_ETHERNET,
	IPC_TYPE_MAX
};

/* hdr - app should not change it*/
typedef struct IPC_MSG_HDR_ {
	unsigned char	type;
	unsigned short	len;
	unsigned char	app;
#define IPC_APP_REQUEST	0x1
#define IPC_APP_RESPONSE	0x2
	unsigned char	flag;

	unsigned char	cookie;
	unsigned char	err_chk;
} IPC_MSG_HDR;


/* template */
typedef struct IPC_MSG_ {
	struct list_head list;
	IPC_MSG_HDR		 hdr;
	char			 body[1];
} IPC_MSG;
#define IPC_HEADER_SIZE (sizeof(IPC_MSG) - 1)


/* ethernet ipc */
#define EIPC_MSG_LEN	  (512 + 1024)	
#define EIPC_MSG_BODY_LEN (EIPC_MSG_LEN - sizeof(IPC_MSG_HDR) - sizeof(struct list_head))
typedef struct EIPC_MSG_ {
	struct list_head list;
	IPC_MSG_HDR		 hdr;
	char			 body[EIPC_MSG_BODY_LEN];
} EIPC_MSG;

typedef void (*EIPC_NOTIFY)(EIPC_MSG *msgP);

/* Public APIs */
uint8_t ipcChksum(IPC_MSG *msg);
void ipcEthernetRegister(int app, EIPC_NOTIFY notifyFunc);
void ipcEthernetDeregister(int app);
int ipcEthernetSend(EIPC_MSG *msg);
void ipcEthernetInit(uint32_t ip);

#endif /* __INCcommIpcApi */
