/*******************************************************************************

NAME			$RCSfile: commRpt.h,v $
SUMMARY			Report mechanism for PikesPeak
VERSION			$Revision: 1.5 $
UPDATE DATE		$Date: 2009/08/21 08:38:27 $
PROGRAMMER		$Author: luap $

		Copyright 2009 LSI Corporation. All Rights Reserved.

DESCRIPTION:
    Define the functions used to report diagnostics status

REFERENCE:

*******************************************************************************/
#ifndef __INCcommRpt
#define __INCcommRpt

/***  INCLUDES  ***/
#include <commTypes.h>

/***  TYPE DEFINATIONS  ***/
typedef enum commonErrorReportFormat {
	DG_FORMAT_NONE = 0,
	DG_MEMORY_BYTE_FORMAT,
	DG_MEMORY_WORD_FORMAT,
	DG_MEMORY_LONG_FORMAT,
	DG_MEMORY_LL_FORMAT,
	DG_FPGA_DRIVE_FORMAT,
	DG_FPGA_INT_FORMAT,
	DG_FPGA_NVSRAM_FORMAT,
	DG_QE8_IRQ_FORMAT,
	DG_QE8_DG_FORMAT,
	DG_QE8_LOOPBACK_FORMAT,
	DG_QE8_BS_FORMAT,
	DG_PCI_REGISTER_FORMAT,
	DG_PCH_MSG_FORMAT,
	DG_PCH_IO_FORMAT,
	DG_EXPANDER_FLASH_FORMAT,
	DG_EXPANDER_LOOPBACK_FORMAT,
	DG_LSI_FALCON_FORMAT,
	DG_LSI_FALCON_PATTERN_FORMAT	
} commErrRptFormat;

/***  EXTERNAL REFERENCES  ***/
extern VOID commReportError(INT16 com, INT8 item, INT16 code, const char *msg,
		INT64 addr, INT64 exp, INT64 obs, commErrRptFormat format);
extern VOID commPostProgress(const char *msg, INT32 offset, INT32 total);
extern VOID pikespeakDiagFwVersion(VOID);

#define DIAG_TABLE_CHAR_SIZE 	    	0x0800 	//256 x 8 = 2^11 = 2K
#define DIAG_TABLE_SIZE_LOCATION    	0x00000060
#define DIAG_TABLE_BASE_OFFSET      	0x00000064

#define DIAG_USER_CONF_SIZE	    		0x1000	//4K
#define DIAG_USER_CONF_SIZE_LOCATION 	0x00000054
#define DIAG_USER_CONF_OFFSET			0x00001000
#endif //__INCcommRpt
