/*******************************************************************************

NAME            fpgaIdReadDiag.h
SUMMARY         header file for Zebulon FPGA ID read function diagnostics
VERSION         %version: 1 %
UPDATE DATE     %date_modified: Apr 27 19:20 2009 %
PROGRAMMER      %created_by:    Jim Tu %

        Copyright 2009 Quanta Corporation. All Rights Reserved.

DESCRIPTION:
        This file has code to test ID read function of Zebulon FPGA

NOTES:

REFERENCE:

*******************************************************************************/

#ifndef __FPGA_ID_READ_DIAG_H__
#define __FPGA_ID_READ_DIAG_H__

#define CONTROLLER_INDICATOR            0x10
#define CONTROLLER_POSITION_BIT         0x80

#define PIKESPEAK_BOARD_ID             (PIKESPEAK_ID | CONTROLLER_INDICATOR)
#define SOYUZ_BOARD_ID                 (SOYUZ_ID | CONTROLLER_INDICATOR)

//HIC IDs
#define INVALID_HOST_CARD               0x00
#define GLEN_COVE_ID_ISCSI		0x01	//iSCSI host card
#define GLACIER_ID_SAS			0x03	//SAS host card
#define ELK_PARK_ID_IB			0x04	//InfiniBand host card
#define MANITOU_ID_FC			0x05	//Fibre Channel host card
#define DEFAULT_NO_CARD                 0x0F 	//No host card

//FPGA device ID
#define FPGA_DEVICE_ID_VERSION			0x00

/***  Export Function  ***/
INT32 fpgaIdDiag(VOID);
INT32 fpgaUutPosition(VOID);

#endif  //__FPGA_ID_READ_DIAG_H__
