/*******************************************************************************

NAME            fpgaRegAddr.h
SUMMARY         header file for Zebulon/Rocket FPGA register access function
VERSION         %version: 1.01 %
UPDATE DATE     %date_modified: Jul 08 06:40 2011 %
PROGRAMMER      %created_by:    Shawn Wang %

        Copyright 2009-2011 NetApp/LSI Corporation. All Rights Reserved.

DESCRIPTION:
        This file has code to access FPGA register for
        Pikes Peak (Zebulon) / Soyuz (Rocket) RAID controller
	Zebulon/Rocket are basically the same FPGA

NOTES:

REFERENCE:

*******************************************************************************/

#ifndef __FPGA_REGISTER_LIB_H__
#define __FPGA_REGISTER_LIB_H__

#include "fpga-address.h"

/***  Zebulon BAR Address ***/
EXTERN VOID*	gFpgaBar1VirtualP;
EXTERN VOID*	gFpgaBar2VirtualP;

/***  Export Function  ***/
UINT8 	fpgaRegisterRead(UINT32 fpgaOffset);
INT32 	fpgaRegisterWrite(UINT32 fpgaOffset, UINT8 data);
VOID 	fpgaEncodedRegisterWrite(VOID);
VOID 	fpgaRegisterShow(UINT32	fpgaOffset);

#if defined(CHASSIS_WSAS)
INT32 fpgaProtectedRegisterWrite
(
UINT32         fpgaOffset,     //register offset from BAR1
UINT8          data            //8-bit data needs to be written INT32o register
);
#endif
#endif   // FPGA_REGISTER_LIB_H__
