/****************************************************************************
*                                                                           *
* Copyright 2004-2011 NetApp Inc. All rights reserved. This file is         *
* confidential and a trade secret of NetApp Inc. The receipt or             *
* possession of this file does not convey any rights to reproduce or        *
* disclose its contents or to manufacture, use, or sell anything it may     *
* describe, in whole, or in part, without the specific written consent of   *
* LSI Corporation.                                                          *
*                                                                           *
****************************************************************************/
/****************************************************************************
*                                                                           *
* NAME            i2c-address.h                                             *
* SUMMARY                                                                   *
* VERSION         %version: %                                               *
* UPDATE DATE     %date_modified: %                                         *
* PROGRAMMER      %created_by:    Merck Hung %                              *
*                                                                           *
*        Copyright 2002-2011 NetApp Inc. All Rights Reserved.               *
*                                                                           *
* DESCRIPTION:                                                              *
*                                                                           *
****************************************************************************/


// SYSTEM I2C Bus
#if defined(CTRLER_PIKESPEAK)
enum {

	NB_I2C_BUS_0 = -1,	// NB0		, -1, not used for pp
	NB_I2C_BUS_1 = -1,	// NB1		, -1, not used for pp

    PCH_I2C_BUS_0 = 0,  // PCH0			, 0

    FPGA_I2C_BUS_0,     // FPGA 0		, 1
    FPGA_I2C_BUS_1,     // FPGA 1		, 2
    FPGA_I2C_BUS_2,     // FPGA 2		, 3

    MUX_I2C_BUS_0,      // MUX 0		, 4
    MUX_I2C_BUS_1,      // MUX 1		, 5
    MUX_I2C_BUS_2,      // MUX 2		, 6
    MUX_I2C_BUS_3,      // MUX 3		, 7
    MUX_I2C_BUS_4,      // MUX 4		, 8
    MUX_I2C_BUS_5,      // MUX 5		, 9
    MUX_I2C_BUS_6,      // MUX 6		, 10
    MUX_I2C_BUS_7,      // MUX 7		, 11

    HIC_MUX_I2C_BUS_0,  // HIC MUX 0	, 12
    HIC_MUX_I2C_BUS_1,  // HIC MUX 1	, 13
    HIC_MUX_I2C_BUS_2,  // HIC MUX 2	, 14
    HIC_MUX_I2C_BUS_3,  // HIC MUX 3	, 15
    HIC_MUX_I2C_BUS_4,  // HIC MUX 4	, 16
    HIC_MUX_I2C_BUS_5,  // HIC MUX 5	, 17
    HIC_MUX_I2C_BUS_6,  // HIC MUX 6	, 18
    HIC_MUX_I2C_BUS_7,  // HIC MUX 7	, 19
};
//#elif defined(CTRLER_SOYUZ)
#else
enum {

	NB_I2C_BUS_0 = -1,	// NB0			,
	NB_I2C_BUS_1 = -1,  // NB1			,

    PCH_I2C_BUS_0 = 0,	// PCH0			, 0

    FPGA_I2C_BUS_0,     // FPGA 0		, 1
    FPGA_I2C_BUS_1,     // FPGA 1		, 2
    FPGA_I2C_BUS_2,     // FPGA 2		, 3

    MUX_I2C_BUS_0,      // MUX 0		, 4
    MUX_I2C_BUS_1,      // MUX 1		, 5
    MUX_I2C_BUS_2,      // MUX 2		, 6
    MUX_I2C_BUS_3,      // MUX 3		, 7
    MUX_I2C_BUS_4,      // MUX 4		, 8
    MUX_I2C_BUS_5,      // MUX 5		, 9
    MUX_I2C_BUS_6,      // MUX 6		, 10
    MUX_I2C_BUS_7,      // MUX 7		, 11

	HIC_MUX_I2C_BUS_0,	// HIC MUX 0	, 12
	HIC_MUX_I2C_BUS_1,  // HIC MUX 1	, 13
	HIC_MUX_I2C_BUS_2,  // HIC MUX 2	, 14
	HIC_MUX_I2C_BUS_3,  // HIC MUX 3	, 15
	HIC_MUX_I2C_BUS_4,  // HIC MUX 4	, 16
	HIC_MUX_I2C_BUS_5,  // HIC MUX 5	, 17
	HIC_MUX_I2C_BUS_6,  // HIC MUX 6	, 18
	HIC_MUX_I2C_BUS_7,  // HIC MUX 7	, 19
};
#endif


//
// I2C Addresses
//
#define DIMM0_SPD_ADDR					(0xA0 >> 1)
#define DIMM1_SPD_ADDR					(0xA2 >> 1)
#define DIMM2_SPD_ADDR					(0xA4 >> 1)
#define DIMM3_SPD_ADDR					(0xA8 >> 1)

#define CK505_ADDR						(0xD2 >> 1)
#define CK420_ADDR						(0xD2 >> 1)

#define DB1201_ADDR						(0xD8 >> 1)
#define ISL90728_ADDR					(0x7C >> 1)

#define SB_SLV_ADDR						(0x44 >> 1)
#define NB_SLV_ADDR						(0xE8 >> 1)

#define PCA9548_ADDR					(0xE2 >> 1)
#define PCA9548_HIC_ADDR				(0xE0 >> 1)

#define MAX7310_0_ADDR					(0x40 >> 1)
#define MAX7310_1_ADDR					(0x42 >> 1)
#define MAX7310_2_ADDR					(0x44 >> 1)
#define TMP75_0_ADDR                    (0x94 >> 1)
#define TMP75_1_ADDR                    (0x96 >> 1)

#define PSU0_ADDR						(0xB0 >> 1)
#define PSU1_ADDR						(0xB2 >> 1)
#define PSU0_VPD_ADDR					(0xA0 >> 1)
#define PSU1_VPD_ADDR					(0xA2 >> 1)

#define PSU0PSMI_ADDR					(0x4C >> 1)
#define PSU1PSMI_ADDR					(0x4E >> 1)
#define PSU0PSMI_VPD_ADDR				(0x7C >> 1)
#define PSU1PSMI_VPD_ADDR				(0x7E >> 1)

#define PSU0PSMI_TESTMP_ADDR            (0x5C >> 1)

#define FAN0_CRU_VPD_ADDR				(0xA8 >> 1)
#define FAN1_CRU_VPD_ADDR				(0xAA >> 1)

#define SFP_EEPROM_ADDR					(0xA0 >> 1)
#define SFP_DPORT_ADDR					(0xA2 >> 1)
#define SFP_QE8SLV_ADDR					(0xC8 >> 1)
#define BE2_DPORT_ADDR					(0xAA >> 1)

#define SAS2008_EEPROM_ADDR             (0xA0 >> 1)
#define SAS2308_EEPROM_ADDR             (0xA0 >> 1)

#define LTC4100_ADDR					(0x12 >> 1)
#define BBU_GASGAUGE_ADDR				(0x16 >> 1)
#define BBU_BATTEEPROM_ADDR				(0xA0 >> 1)
#define BBU_CONN2_ADDR					(0x14 >> 1)
#define BBU_CONN3_ADDR					(0xC8 >> 1)

#define VPD_EEPROM_ADDR					(0xAC >> 1)
#define MAX6657_ADDR                    (0x98 >> 1)
#define LM84_ADDR						(0x30 >> 1)
#define PLX_8648_SLAVE_ADDR             (0xDE >> 1)
#define PLX_8649_SLAVE_ADDR             (0x3E >> 1)
#define CLKBUF_ADDR						(0xDA >> 1)
#define PLXSWH_ADDR						(0x74 >> 1)

#define INA209_0_ADDR					(0x80 >> 1)
#define INA209_1_ADDR                   (0x82 >> 1)
#define INA209_2_ADDR                   (0x84 >> 1)
#define INA209_3_ADDR                   (0x86 >> 1)
#define INA209_4_ADDR                   (0x88 >> 1)
#define INA209_5_ADDR                   (0x8A >> 1)
#define INA209_6_ADDR                   (0x8C >> 1)
#define INA209_7_ADDR                   (0x8E >> 1)
#define INA209_8_ADDR                   (0x90 >> 1)
#define INA209_9_ADDR                   (0x92 >> 1)

#define PCA9545_ADDR					(0xE0 >> 1)
#define PCA9555_0_ADDR					(0x40 >> 1)
#define PCA9555_1_ADDR                  (0x42 >> 1)
#define PCA9555_2_ADDR                  (0x46 >> 1)


//
// I2C Driver Name
//
#define PCA9548_NAME					"pca9548"
#define MAX7310_NAME                    "max7310"
#define TMP75_NAME						"tmp75"
#define PSU0MCU_NAME					"psu0_mcu"
#define PSU1MCU_NAME					"psu1_mcu"
#define PSU0PSMI_MCU_NAME				"psu0psmi_mcu"
#define PSU1PSMI_MCU_NAME				"psu1psmi_mcu"
#define LTC4100_NAME                    "ltc4100"
#define BBU_GASGAUGE_NAME               "bbu_gasgauge"
#define BBU_BATTEEPROM_NAME             "bbu_batteeprom"
#define MAX6657_NAME					"max6657"
#define LM84_NAME						"lm84"

#define DIMM_SPD_NAME					"24c02"
#define EEPROM_64KB_NAME				"24c64"
#define EEPROM_2KB_NAME					"24c02"
#define EEPROM_PSU_NAME					"24c64"

#define CK420_NAME						"ck420"
#define CK505_NAME						"ck505"
#define DB1201_NAME						"db1201"
#define ISL90728_NAME					"isl90728"
#define IBEXPEAK_NAME					"ibexpeak"
#define PATSBURG_NAME					"patsburg"
#define JF_NAME							"jasperforest"

#define SFP_EEPROM_NAME					"24c02"
#define SFP_DPORT_NAME					"sfp_dport"
#define SFP_QE8SLV_NAME					"qe8slv"
#define BE2_DPORT_NAME					"be2_dport"

#define CLKBUF_NAME						"clockbuffer"
#define PLXSWH_NAME						"plxswitch"

#define SAS2008_EEPROM_NAME             "24c64"
#define SAS2308_EEPROM_NAME             "24c64"

#define INA209_NAME						"ltc4245"
#define PCA9545_NAME					"pca9545"
#define PCA9555_NAME					"pca9555"


struct i2c_client *getI2cMuxClient( char *devName, unsigned short slvAddr, unsigned char busNo );
struct i2c_client *getI2cDevClient( char *devName, unsigned short slvAddr, unsigned char busNo );

struct i2c_client *getI2cHicMuxClient( char *devName, unsigned short slvAddr, unsigned char busNo );
struct i2c_client *getI2cHicDevClient( char *devName, unsigned short slvAddr, unsigned char busNo );

struct i2c_client *getI2cTestMuxClient( char *devName, unsigned short slvAddr, unsigned char busNo );
struct i2c_client *getI2cTestDevClient( char *devName, unsigned short slvAddr, unsigned char busNo );


