/****************************************************************************
*                                                                           *
* Copyright 2004-2011 NetApp Inc. All rights reserved. This file is         *
* confidential and a trade secret of NetApp Inc. The receipt or             *
* possession of this file does not convey any rights to reproduce or        *
* disclose its contents or to manufacture, use, or sell anything it may     *
* describe, in whole, or in part, without the specific written consent of   *
* LSI Corporation.                                                          *
*                                                                           *
****************************************************************************/
/****************************************************************************
*                                                                           *
* NAME            midplane.h                                                *
* SUMMARY                                                                   *
* VERSION         %version: %                                               *
* UPDATE DATE     %date_modified: %                                         *
* PROGRAMMER      %created_by:    Merck Hung %                              *
*                                                                           *
*        Copyright 2002-2011 NetApp Inc. All Rights Reserved.               *
*                                                                           *
* DESCRIPTION:                                                              *
*                                                                           *
****************************************************************************/


//
// Definitions
//
typedef enum _midplaneHwId {
	
	MIDPLANE_UNKNOWN = 0x00,

	MIDPLANE_TEST = 0x0F,
	MIDPLANE_STANDARD = 0xFF,

	MIDPLANE_EBBETS = 0x04,
	MIDPLANE_CAMDEN = 0x02,
	MIDPLANE_WEMBLEY = 0x09,
	MIDPLANE_WEMBLEY_EVT = 0x01,

} midplaneHwId_t;


typedef enum _midplaneFlag {

	MPF_UNKNOWN = 0x0000,
	MPF_TEST = 0x0001,

	MPF_EBBETS = 0x0002,
	MPF_CAMDEN = 0x0004,
	MPF_WSAS = 0x0008,

	MPF_STANDARD = 0xFFFE,
	MPF_ALL = 0xFFFF,

} midplaneFlag_t;


typedef enum _controllerHwId {

    CONTROLLER_UNKNOWN = 0x00,
	CONTROLLER_PIKESPEAK = 0x1E,
	CONTROLLER_SOYUZ = 0x14,

} controllerHwId_t;


typedef enum _controllerFlag {

	CTF_UNKNOWN = 0x0000,
	CTF_PIKESPEAK = 0x0001,
	CTF_SOYUZ = 0x0002,
	CTF_ALL = 0xFFFF,

} controllerFlag_t;


typedef enum _hostInterfaceCardHwId {

	HIC_INVALID_UNKNOWN = 0x00,
	HIC_ISCSI_GLEN_COVE = 0x01,
	HIC_SAS_GLACIER = 0x03,
	HIC_IB_ELK_PARK = 0x04,
	HIC_FC_MANITOU = 0x05,
	HIC_SAS_ACADIA = 0x05,
	HIC_NO_CARD = 0x0F,

} hostInterfaceCardHwId_t;


typedef enum _hostInterfaceCardType {

	HIC_TYPE_NONE = 0x00,
	HIC_TYPE_FC,
	HIC_TYPE_ISCSI,
	HIC_TYPE_IB,
	HIC_TYPE_SAS,

} hostInterfaceCardType_t;


typedef enum _hostInterfaceCardFlag {

	HICF_UNKNOWN = 0x0000,
	HICF_ISCSI_GLEN_COVE = 0x0001,
	HICF_SAS_GLACIER = 0x0002,
	HICF_IB_ELK_PARK = 0x0004,
	HICF_FC_MANITOU = 0x0008,
	HICF_ALL = 0xFFFF,

} hostInterfaceCardFlag_t;


//
// Structures
//
typedef struct _i2cDevAttr {

    char                    *i2cDevName;
    unsigned short          i2cSlaveAddr;
    unsigned char           i2cBusNo;
    struct i2c_client       *i2cClnt;
    void                    *i2cPlatData;
    unsigned short          controllerFlag;
    unsigned short          midplaneFlag;

} i2cDevAttr_t;


typedef struct _i2cHicDevAttr {

    char                    *i2cDevName;
    unsigned short          i2cSlaveAddr;
    unsigned char           i2cBusNo;
    struct i2c_client       *i2cClnt;
	unsigned short			hicFlag;

} i2cHicDevAttr_t;


//
// Prototypes
//
unsigned short identifyMidplaneHwID( void );
unsigned short identifyMidplaneFlag( void );
unsigned short identifyMidplaneType( void );

unsigned short identifyControllerHwID( void );
unsigned short identifyControllerFlag( void );

unsigned short identifyHostInterfaceCardHwID( void );
unsigned short identifyHostInterfaceCardType( void );
unsigned short identifyHostInterfaceCardFlag( void );


