//
// Alan Wang, 20100401
//
#include <linux/wait.h>
#include <linux/mm.h>
#include <linux/version.h>
#include <linux/module.h>
#include <linux/kallsyms.h>
#include <linux/semaphore.h>


#define sslock_E	enum sslock_Enum
sslock_E {
//	SSLOCK_ParamRW,
	SSLOCK_IPC_TX,
	SSLOCK_Sys_RunMap,
	SSLOCK_lock_UUT,
	SSLOCK_CommonNTBCPU,
	SSLOCK_CommonNTBDMA,
	SSLOCK_CommonDMA,

	SSLOCK_NUM
};
spinlock_t	sslock_Data[SSLOCK_NUM];


#define sslock_build(name)	\
void sslock_##name(void)	\
{				\
	spin_lock(&sslock_Data[SSLOCK_##name]);\
}				\
EXPORT_SYMBOL(sslock_##name);	\
void ssunlock_##name(void)	\
{				\
	spin_unlock(&sslock_Data[SSLOCK_##name]);\
}				\
EXPORT_SYMBOL(ssunlock_##name);


//sslock_build(ParamRW)
sslock_build(IPC_TX)
sslock_build(lock_UUT)
sslock_build(CommonNTBCPU)
sslock_build(CommonNTBDMA)
sslock_build(CommonDMA)


#if 0
void sslock_ParamRW(void)
void ssunlock_ParamRW(void)
{
	spin_lock(&sslock_Data[SSLOCK_ParamRW]);
}

{
	spin_unlock(&sslock_Data[SSLOCK_ParamRW]);
}

void sslock_IPC_TX(void)
{
	spin_lock(&sslock_Data[SSLOCK_IPC_TX]);
}

void ssunlock_IPC_TX(void)
{
	spin_unlock(&sslock_Data[SSLOCK_IPC_TX]);
}
#endif


//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,30)
static DECLARE_MUTEX(ss_InOrderMutex);
#else
static DEFINE_SEMAPHORE(ss_InOrderMutex);
#endif

void sslock_GetInOrderMutex(void)
{
	down(&ss_InOrderMutex);
}

void sslock_ReleaseInOrderMutex(void)
{
	up(&ss_InOrderMutex);
}

void sslock_Init(void)
{
	int	i;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,30)
	init_MUTEX(&ss_InOrderMutex);//This function will be called several times
#else
	sema_init(&ss_InOrderMutex, 1);//This function will be called several times
#endif

	for(i=0; i<SSLOCK_NUM; i++)
		spin_lock_init(&sslock_Data[i]);
}


