#ifndef BBUDAPI_H
#define BBUDAPI_H

#include "BBUBaseClassDDAPI.hpp"
#include "BaseClassDAPI.hpp"
#include <dirent.h>
#include "I2CDAPI.hpp"
#include "BBU_I2C_TI_bq40z50.hpp"

#define  BBU_NUMBER 10

class BBUDAPI : public BaseClassDAPI
{
    public:
                          BBUDAPI(STRING className);
                          ~BBUDAPI();

                ErrorMsg* Get_BBU_List(BBUBaseClassDDAPI BBU_list[], int *count);
                ErrorMsg* Get_BBU_List(list<string> *BBU_list);
                ErrorMsg* Get_BBU_Device(string bbu_name, BBUBaseClassDDAPI **BBU);
                ErrorMsg* Charge(string bbu_name);
                ErrorMsg* Discharge(string bbu_name);
                ErrorMsg* GetChargeStatus(string bbu_name, int *status);
                ErrorMsg* Read(string bbu_name, int start_address, int end_address, int *data, int *count);
                ErrorMsg* Write(string bbu_name, int address, int *data, int count, int *numberRealWrite);
                ErrorMsg* getBBUInformation(string bbuName);
//                ErrorMsg* Set_Threshold_Hight(string name, float temp);
//                ErrorMsg* Set_Threshold_Low(string name, float temp);

    protected:

    private:
//                ErrorMsg* Add_CPU_Temperature_item(string cpu_hwmon_path);
//                ErrorMsg* Add_DIMM_Temperature_item(string dimm_hwmon_path);
                ErrorMsg* Add_I2C_BBU_item(I2CDevice *i2c_device);
//                ErrorMsg* scan_cpu_temperature();
//                ErrorMsg* scan_dimm_temperature();
                ErrorMsg* scan_i2c_BBU();

                BBUBaseClassDDAPI  *m_bbu[BBU_NUMBER];
                int                m_count;
                ErrorMsg           *m_errorCode;
};

#endif
