#ifndef SATADAPI_HPP
#define SATADAPI_HPP

#include <iostream>
#include <iomanip>
#include <sys/time.h>

#include "BaseClassDAPI.hpp"
#include "SATADDAPI.hpp"

/// @class      SATADAPI SATADAPI.hpp "SATADAPI.hpp"
/// @brief      Provide diagnostic and utility APIs for SATA module
/// @param      m_pSATADDAPI is a pointer to SATADDAPI
class SATADAPI: public BaseClassDAPI
{
public:
     string m_strOutputResultString;

     SATADAPI(STRING in_szClassName);
     virtual ~SATADAPI(void);

     ErrorMsg *IOCTL(UINT32 in_u32LogicalID, SATAIOCTLOperation in_eOperation);
     ErrorMsg *generateSATAList(/*SATAInformationXMLData *inout_pXMLData*/);

     ErrorMsg *readBySCSI(UINT32 in_u32LogicalID, UINT32 in_u32StartSector, UINT32 in_u32SectorCount);
     ErrorMsg *writeBySCSI(UINT32 in_u32LogicalID, UINT32 in_u32StartSector, UINT32 in_u32SectorCount);

     ErrorMsg *getLogicalIdByName(string in_strWellKnownName, UINT32 *out_u32LogicalID);
     ErrorMsg *getDataByID(UINT32 in_u32LogicalID, SATADataElement in_eSATADataElement, string *out_strpReturnData);
     ErrorMsg *getSMARTInfoByID(UINT32 in_u32LogicalID, UINT32 in_u32StartIDNumber, UINT32 in_u32EndIDNumber, string *out_strpReturnData);
     ErrorMsg *getErrorRegisterByID(UINT32 in_u32LogicalID, SATAErrorElement in_eSATAErrorElement, string *out_strpReturnData);
     ErrorMsg *getDataByName(string in_strWellKnownName, SATADataElement in_eSATADataElement, string *out_strpReturnData);

     ErrorMsg *identifyCommandTest(UINT32 in_u32LogicalID);
     ErrorMsg *readPerformanceTest(UINT32 in_u32LogicalID, UINT32 in_u32StartSector, UINT32 in_u32TestSizeMB);
     ErrorMsg *writePerformanceTest(UINT32 in_u32LogicalID, UINT32 in_u32StartSector, UINT32 in_u32TestSizeMB);
     ErrorMsg *readwriteTest(UINT32 in_u32LogicalID, UINT32 in_u32StartSector, UINT32 in_u32TestSizeMB);

protected:

private:
     SATADDAPI *m_pSATADDAPI;
};

#endif
