#include "BBU_I2C_TI_bq40z50.hpp"


BBU_I2C_TI_bq40z50 :: BBU_I2C_TI_bq40z50()
{

}



BBU_I2C_TI_bq40z50 :: ~BBU_I2C_TI_bq40z50()
{

}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Temperature(float *temperature)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      temperature_raw, count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, Temperature, Temperature, &temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   *temperature = temperature_raw * 0.1 - 273.15;

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Current(int *current)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
//   int      temperature_raw[2], count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   /*m_pErrorMsg = i2c_driver.read(i2c_device_name, 0x02, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }*/

   *current = 1200; //Debug

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Max_Error(int *max_error)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, MaxError, MaxError, max_error, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Charger_System_State(int *cs_state)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
//   int      temperature_raw[2], count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   /*m_pErrorMsg = i2c_driver.read(i2c_device_name, 0x02, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }*/

   *cs_state = 0; //Debug

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_FW_BBU_State(int *fw_bbu_state)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, BatteryStatus, BatteryStatus, fw_bbu_state, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Voltage(int *voltage)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, Voltage, Voltage, voltage, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Charging_Current(int *charging_current)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, ChargingCurrent, ChargingCurrent, charging_current, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Gas_Gauge_Stat(int *gas_gauge_stat)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
//   int      temperature_raw[2], count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   /*m_pErrorMsg = i2c_driver.read(i2c_device_name, 0x02, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }*/

   *gas_gauge_stat = 1; //Debug

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Charger_Sys_Control(int *charger_sys_control)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
//   int      temperature_raw[2], count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   /*m_pErrorMsg = i2c_driver.read(i2c_device_name, 0x02, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }*/

   *charger_sys_control = 1; //Debug

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Relative_State_Charge(int *relative_state_charge)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, RelativeStateOfCharge, RelativeStateOfCharge, relative_state_charge, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Absolute_State_Charge(int *absolute_state_charge)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, AbsoluteStateOfCharge, AbsoluteStateOfCharge, absolute_state_charge, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Remaining_Capacity(int *remaining_Capacity)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, RemainingCapacity, RemainingCapacity, remaining_Capacity, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Full_Charge_Capacity(int *full_charge_capacity)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, FullChargeCapacity, FullChargeCapacity, full_charge_capacity, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Time_Empty(int *time_empty)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, RunTimeToEmpty, RunTimeToEmpty, time_empty, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Average_Time_Empty(int *average_time_empty)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, AverageTimeToEmpty, AverageTimeToEmpty, average_time_empty, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Average_Time_Full(int *average_time_full)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, AverageTimeToFull, AverageTimeToFull, average_time_full, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Cycle_Count(int *cycle_Count)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, CycleCount, CycleCount, cycle_Count, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Design_Capacity(int *design_capacity)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, DesignCapacity, DesignCapacity, design_capacity, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Design_Voltage(int *design_voltage)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, DesignVoltage, DesignVoltage, design_voltage, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Specification_Info(int *specification_info)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, SpecificationInfo, SpecificationInfo, specification_info, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Date_Manufacture(string *date_manufacture)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name, s;
   int      date_raw, count;
   stringstream ss(s);

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, ManufactureDate, ManufactureDate, &date_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   ss << ((date_raw & 0x01E0) >> 5) << "/";   //Month, bit 5~8
   ss << (date_raw & 0x1F) << "/";            //Day, bit 0~4
   ss << ((date_raw & 0xFE00) >> 9) + 1980;   //Year, bit 9~15

   *date_manufacture = ss.str();

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Serial_Number(int *serial_Number)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, SerialNumber, SerialNumber, serial_Number, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Pack_Status_Config(int *pack_status_config)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
//   int      temperature_raw[2], count;
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   /*m_pErrorMsg = i2c_driver.read(i2c_device_name, 0x02, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }*/

   *pack_status_config = 1234; //Debug

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Manufacturer_Name(string *manufacturer_name)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      temperature_raw[64], count, i;
   char     manufacturer_char[64];
   
   count = 64;
   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, ManufacturerName, ManufacturerName, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   for(i = 0; i < count; i++)
   {
      manufacturer_char[i] = temperature_raw[i];
   }
   manufacturer_char[i] = '\0';

   manufacturer_name->append(manufacturer_char);

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Device_name(string *device_name)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      temperature_raw[64], count, i;
   char     device_char[64];
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, DeviceName, DeviceName, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   for(i = 0; i < count; i++)
   {
      device_char[i] = temperature_raw[i];
   }
   device_char[i] = '\0';

   device_name->append(device_char);

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Device_Chemistry(string *device_chemistry)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      temperature_raw[64], count, i;
   char     chemistry_char[64];
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, DeviceChemistry, DeviceChemistry, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   for(i = 0; i < count; i++)
   {
      chemistry_char[i] = temperature_raw[i];
   }
   chemistry_char[i] = '\0';

   device_chemistry->append(chemistry_char);

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Get_Design_Data(string *design_data)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;
   int      temperature_raw[64], count, i;
   char     design_data_char[64];
   

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, ManufacturerData, ManufacturerData, temperature_raw, &count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   for(i = 0; i < count; i++)
   {
      design_data_char[i] = temperature_raw[i];
   }
   design_data_char[i] = '\0';

   design_data->append(design_data_char);

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Read(string name,int start_address, int end_address, int *data, int *count)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.read(bbu_device_name, start_address, end_address, data, count);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      //printf("BBU_I2C_TI_bq40z50 :: Read fail\n");
      return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Write(string name, int address, int *data, int count, int *numberRealWrite)
{
   I2CDDAPI i2c_driver("I2C_driver");
   string   bbu_device_name;

   bbu_device_name = Get_name();

   //Get the BBU raw data
   m_pErrorMsg = i2c_driver.write(bbu_device_name, address, data, count, numberRealWrite);
   if (m_pErrorMsg != NO_ERROR_MSG)
   {
      printf("BBU_I2C_TI_bq40z50 :: Write fail\n");
      //return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
   }

   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Charge()
{
    PCIDDAPI      pciDriverAPI("BBU_PCI_DDAPI");
    MemoryDDAPI   memoryDriver("BBU_MEM_DDAPI");
    UINT32        u32Bar;
    UINT8         ret;
    UINT8         fpgaEncodedWriteSequence[8] = {0x80, 0x01, 0x02, 0x84, 0x89, 0x93, 0x27, 0xCE};
    UINT8         index;

    //Get the FPGA bar address
    m_pErrorMsg = pciDriverAPI.getBarByBDF(0, 0x72, 0x00, 0x00, 0, &u32Bar);
    if (m_pErrorMsg != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
    }

    //Get FPGA Protected Write 2 Register (0x32) status first
    ret = memoryDriver.read8(u32Bar + 0x32);

    //Set bit 1 to '0' for charge(bit 1:EN_DISCH)
    ret = ret & 0xFD;

    //Un-protected Write Register first
    for (index = 0; index < 8; index++)
    {
        memoryDriver.write(u32Bar + 0x30, fpgaEncodedWriteSequence[index]);
    }


    //Write data back to Protected Write 2 Register
    m_pErrorMsg = memoryDriver.write(u32Bar + 0x32, ret);
    if (m_pErrorMsg != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
    }

    //To be define and implement

    return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Discharge()
{
    PCIDDAPI      pciDriverAPI("BBU_PCI_DDAPI");
    MemoryDDAPI   memoryDriver("BBU_MEM_DDAPI");
    UINT32        u32Bar;
    UINT8         ret;
    UINT8         fpgaEncodedWriteSequence[8] = {0x80, 0x01, 0x02, 0x84, 0x89, 0x93, 0x27, 0xCE};
    UINT8         index;

    //Get the FPGA bar address
    m_pErrorMsg = pciDriverAPI.getBarByBDF(0, 0x72, 0x00, 0x00, 0, &u32Bar);
    if (m_pErrorMsg != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
    }

    //Get FPGA Protected Write 2 Register (0x32) status first
    ret = memoryDriver.read8(u32Bar + 0x32);

    //Set bit 1 to '1' for discharge(bit 1:EN_DISCH)
    ret = ret | 0x02;

    //Un-protected Write Register first
    for (index = 0; index < 8; index++)
    {
        memoryDriver.write(u32Bar + 0x30, fpgaEncodedWriteSequence[index]);
    }

    //Write data back to Protected Write 2 Register
    m_pErrorMsg = memoryDriver.write(u32Bar + 0x32, ret);
    if (m_pErrorMsg != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
    }

    //To be define and implement

    return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: ShowChargeStatus(int *status)
{
    PCIDDAPI      pciDriverAPI("BBU_PCI_DDAPI");
    MemoryDDAPI   memoryDriver("BBU_MEM_DDAPI");
    UINT32        u32Bar;
    UINT8         ret;

    //Get the FPGA bar address
    m_pErrorMsg = pciDriverAPI.getBarByBDF(0, 0x72, 0x00, 0x00, 0, &u32Bar);
    if (m_pErrorMsg != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_THRESHOLD_HIGHT, "I2C_ST_STTS2002", m_pErrorMsg);
    }

    //Get FPGA Protected Write 2 Register (0x32) status first
    ret = memoryDriver.read8(u32Bar + 0x32);

    //Get bit 1 for charge(bit 1:EN_DISCH)
    *status = (ret & 0x02) >> 1;

    return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Temperature(float temperature)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Current(int current)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Max_Error(int max_error)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Charger_System_State(int cs_state)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_FW_BBU_State(int fw_bbu_state)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Voltage(float voltage)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Charging_Current(int charging_current)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Gas_Gauge_Stat(int gas_gauge_stat)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Charger_Sys_Control(int charger_sys_control)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Relative_State_Charge(int relative_state_charge)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Absolute_State_Charge(int absolute_state_charge)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Remaining_Capacity(int remaining_Capacity)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Full_Charge_Capacity(int full_charge_capacity)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Time_Empty(int time_empty)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Average_Time_Empty(int average_time_empty)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Average_Time_Full(int average_time_full)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Cycle_Count(int cycle_Count)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Design_Capacity(int design_capacity)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Design_Voltage(int design_voltage)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Specification_Info(int specification_info)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Date_Manufacture(string date_manufacture)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Serial_Number(string serial_Number)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Pack_Status_Config(int pack_status_config)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Manufacturer_Name(string manufacturer_name)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Device_name(string device_name)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Device_Chemistry(string device_name)
{
   return NO_ERROR_MSG;
}



ErrorMsg*
BBU_I2C_TI_bq40z50 :: Set_Design_Data(string device_name)
{
   return NO_ERROR_MSG;
}


