#ifndef SATADDAPISTRUCT_HPP
#define SATADDAPISTRUCT_HPP

#include "BaseClassDDAPI.hpp"

using namespace std;

typedef struct SMARTAttribute
{
     UINT32 u32IDNumber;
     string strName;
     string strCurrentValue;
     string strWorstValue;
     string strThresholdValue;
     string strReadableValue;
     string strRawData;
     string strType;
     string strUpdate;
     string strHealthStatus;
     string strPastHealthStatus;
} SMARTAttributeStruct;

typedef struct SATAPort
{
     // basic info & data element
     UINT32 u32LogicalID;
     UINT32 u32PortNumber;
     string strPortWellKnownName;
     string strDriveWellKnownName;
     string strDeviceNodeName;
     string strSGDeviceNodeName;
     string strSerialNumber;
     string strModelName;
     string strFirmwareVersion;
     string strCapacityMB;
     string strLinkDetection;
     string strLinkSpeed;
     string strTemperature;

     // SMART info
     string strSMARTSupport;
     list <SMARTAttributeStruct> SMARTAttributeList;
     string strSMARTDiskHealthStatus;

     // statistics
     UINT32 u32PortErrorRegisters;
     UINT32 u32PortStatusRegisters;
} SATAPortStruct;

typedef struct SATAController
{
     // basic info
     UINT32                u32LogicalID;
     UINT32                u32PortAmount;
     UINT32                u32ControllerNumber;
     string                strControllerWellKnownName;
     string                strControllerAddress;
     UINT32                u32Domain;
     UINT32                u32Bus;
     UINT32                u32Dev;
     UINT32                u32Func;
     
     // port list
     list <SATAPortStruct> SATAPortList;
} SATAControllerStruct;

#endif
