#include "Temperature_SATA.hpp"



Temperature_SATA :: Temperature_SATA(STRING  ClassName) : TemperatureGeneric(ClassName)
{
    m_SATADdapi = new SATADDAPI("TEMP_SATA");
    if(m_SATADdapi != NULL)
    {
        m_SATADdapi->generateSATAList();
    }



}



Temperature_SATA :: ~Temperature_SATA()
{
    if(m_SATADdapi != NULL)
        delete m_SATADdapi;
}


ErrorMsg*  Temperature_SATA :: getTemperatureNameList(list<string> *pTemperatureList)
{
    //printf("%s\n", __PRETTY_FUNCTION__);;
    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;

    string tempString;
    tempString.clear();

    pErrorMsg = m_SATADdapi->listDrive();
    //pErrorMsg = m_SATADdapi->getDataByName("SATA0-Drive4",eDriveTemperature, &tempString);
    //tempString="Drive0\nDrive1\nDrive2\n";
    //printf("!! %s !!", tempString.c_str());

    if(pErrorMsg == NO_ERROR_MSG)
    {
        //pTemperatureList->push_front(tempString);
    }
    else
    {
        //return XXXXXXXXX Error Message XXXXX
    }



    return pErrorMsg;
}


ErrorMsg*  Temperature_SATA :: getDataByName(STRING WellKnownName,
                                               TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
                                               list<string> *returnDataInfo)
{
    //printf("%s\n", __PRETTY_FUNCTION__);;
    //printf("%s\n", __PRETTY_FUNCTION__);

    //ErrorMsg*   pErrorMsg = NO_ERROR_MSG;

/*

    printf("%s\n", __func__);
    printf("WellKnownName:%s\n", WellKnownName);
    printf("TemperatureDataElement:%d\n", TemperatureDataElement);
*/


    switch(TemperatureDataElement)
    {
        case TEMPERATURE_DATA_ALL_INFO:
            //TemperatureDataElement=TEMPERATURE_DATA_ALL_INFO;
            break;
        case TEMPERATURE_DATA_CURRENT_TEMPERATURE:
        	getCurrentTemperatureList(WellKnownName, returnDataInfo);
            //pErrorMsg = getCurrentTemperatureList(WellKnownName, returnDataInfo);
            break;

        case TEMPERATURE_DATA_THRESHOLD_HIGH0:
        	getThresholdHigh0List(WellKnownName, returnDataInfo);
            //pErrorMsg = getThresholdHigh0List(WellKnownName, returnDataInfo);
            break;

        case TEMPERATURE_DATA_THRESHOLD_HIGH1:
        	getThresholdHigh1List(WellKnownName, returnDataInfo);
            //pErrorMsg = getThresholdHigh1List(WellKnownName, returnDataInfo);
            break;

        case TEMPERATURE_DATA_THRESHOLD_LOW0:
        	getThresholdLow0List(WellKnownName, returnDataInfo);
            //pErrorMsg = getThresholdLow0List(WellKnownName, returnDataInfo);
            break;

        case TEMPERATURE_DATA_THRESHOLD_LOW1:
        	getThresholdLow1List(WellKnownName, returnDataInfo);
            //pErrorMsg = getThresholdLow1List(WellKnownName, returnDataInfo);
            break;

        default:
            //return -1;
            break;
    }

    return NO_ERROR_MSG;
}



ErrorMsg* Temperature_SATA :: getCurrentTemperatureList(STRING WellKnownName,
                                                        list<string> *returnDataInfo)
{
    //printf("%s\n", __PRETTY_FUNCTION__);

	ERRORCODE errorCode = NO_ERROR;
    ErrorMsg* pErrorMsg = NO_ERROR_MSG;
    string tempString;
    tempString.clear();
/*

    printf("%s\n", __func__);
    printf("WellKnownName:%s\n", WellKnownName);
*/


    pErrorMsg = m_SATADdapi->getDataByName(WellKnownName,  eDriveTemperature, &tempString);

    //printf("tempString=%s\n", tempString.c_str());
    if(pErrorMsg != NO_ERROR_MSG)
    {
    	return returnErrorMsg((ERRORCODE)(ERROR_TEMPERATURE_DDAPI_GET_CURRENT_TEMPERATURE | errorCode), NULL, pErrorMsg);
    }
    else
    {
    	returnDataInfo->push_back(tempString);
    }
    return NO_ERROR_MSG;
}



ErrorMsg*   Temperature_SATA :: getThresholdHigh0List(STRING WellKnownName,
                                                     list<string> *returnDataInfo)
{


    return NO_ERROR_MSG;
}


ErrorMsg*   Temperature_SATA :: getThresholdLow0List(STRING WellKnownName,
                                                    list<string> *returnDataInfo)
{


    return NO_ERROR_MSG;
}





ErrorMsg*   Temperature_SATA :: getThresholdHigh1List(STRING WellKnownName,
                                                     list<string> *returnDataInfo)
{

    return NO_ERROR_MSG;
}


ErrorMsg*   Temperature_SATA :: getThresholdLow1List(STRING WellKnownName,
                                                    list<string> *returnDataInfo)
{


    return NO_ERROR_MSG;
}


